// Contact.cpp : implementation file
//

#include "stdafx.h"
#include "Contact.h"


// CmyAddressBook

IMPLEMENT_SERIAL( Contact, CObject, VERSIONABLE_SCHEMA | 2);

int Contact::CURRENT_VERSION = 2;

Contact::Contact() :
		m_strFirstName(_T("")),
		m_strLastName(_T("")),
		m_strAddress(_T("")),
		m_strPhone(_T("")),
		m_strMobilePhone(_T("")),
		m_strEmail(_T(""))
{
}

Contact::Contact(const CString& strFirstName, const CString& strLastName, const CString& strAddress,	
				   const CString& strPhone, const CString& strMobilePhone, const CString& strEmail) :
			m_strFirstName(strFirstName),
			m_strLastName(strLastName),
			m_strAddress(strAddress),
			m_strPhone(strPhone),
			m_strMobilePhone(strMobilePhone),
			m_strEmail(strEmail)
{
}

Contact::Contact(const Contact& rhs):
			m_strFirstName(rhs.m_strFirstName),
			m_strLastName(rhs.m_strLastName),
			m_strAddress(rhs.m_strAddress),
			m_strPhone(rhs.m_strPhone),
			m_strMobilePhone(rhs.m_strMobilePhone),
			m_strEmail(rhs.m_strEmail)
{
}

Contact::~Contact()
{
}

Contact& Contact::operator=(const Contact& rhs)
{
	if(this != &rhs)
	{
		m_strFirstName = rhs.m_strFirstName;
		m_strLastName = rhs.m_strLastName;
		m_strAddress = rhs.m_strAddress;
		m_strPhone = rhs.m_strPhone;
		m_strMobilePhone = rhs.m_strMobilePhone;
		m_strEmail = rhs.m_strEmail;
	}

	return *this;
}

void Contact::Serialize( CArchive& ar )
{
	if (ar.IsStoring())
	{
		CRuntimeClass* pruntime = Contact::GetRuntimeClass();
		int oldnr = pruntime->m_wSchema;
		pruntime->m_wSchema = CURRENT_VERSION;

		ar.SerializeClass(pruntime);

		switch (CURRENT_VERSION)
		{
		case 1:
			ar << m_strFirstName << m_strLastName << m_strAddress << m_strPhone;
			break;

		case 2:
			ar << m_strFirstName << m_strLastName << m_strAddress << m_strPhone << m_strMobilePhone << m_strEmail;
			break;

		default:
			// unknown version for this object
			AfxMessageBox(_T("Unknown file version."), MB_ICONSTOP);
			break;
		}

		pruntime->m_wSchema = oldnr;
	}
	// loading code
	else
	{
		ar.SerializeClass(RUNTIME_CLASS(Contact));

		UINT nVersion = ar.GetObjectSchema();

		switch (nVersion)
		{
		case 1:
			ar >> m_strFirstName >> m_strLastName >> m_strAddress >> m_strPhone;
			m_strMobilePhone = _T("");
			m_strEmail = _T("");
			break;

		case 2:
			ar >> m_strFirstName >> m_strLastName >> m_strAddress >> m_strPhone >> m_strMobilePhone >> m_strEmail;
			break;

		default:
			// unknown version for this object
			AfxThrowArchiveException(CArchiveException::badSchema);
			break;
		}
	}
}
