#pragma once

// Contact command target

#include <afxtempl.h>

class Contact : public CObject
{
public:
	DECLARE_SERIAL(Contact);

	Contact();
	Contact(const Contact& rhs);
	Contact(const CString& strFirstName, const CString& strLastName, const CString& strAddress, const CString& strPhone, 
			// these two must have a default value because they are not used in the first version
			const CString& strMobilePhone = _T(""), const CString& strEmail = _T(""));

	Contact& operator=(const Contact& rhs);

	virtual ~Contact();

	void Serialize( CArchive& ar );

	CString GetFirstName() const {return m_strFirstName;}
	CString GetLastName() const {return m_strLastName;}
	CString GetAddress() const {return m_strAddress;}
	CString GetPhoneNumber() const {return m_strPhone;}
	CString GetMobileNumber() const {return m_strMobilePhone;}
	CString GetEmail() const {return m_strEmail;}

	void	SetFirstName(const CString& name) {m_strFirstName = name;}
	void	SetLastName(const CString& name) {m_strLastName = name;}
	void	SetAddress(const CString& addr) {m_strAddress = addr;}
	void	SetPhoneNumber(const CString& phone) {m_strPhone = phone;}
	void	SetMobileNumber(const CString& mobile) {m_strMobilePhone = mobile;}
	void	SetEmail(const CString& email) {m_strEmail = email;}

	static void SetCurrentContactVersion(int nCV) {	CURRENT_VERSION = nCV;	}
	static int	GetCurrentContactVersion() {	return CURRENT_VERSION;	}

private:
	static int	CURRENT_VERSION;
	CString		m_strFirstName;
	CString		m_strLastName;
	CString		m_strAddress;
	CString		m_strPhone;
	CString		m_strMobilePhone;
	CString		m_strEmail;
};

typedef CList<Contact, Contact>		ContactList;
