// SerAddressBookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerAddressBookMDI.h"
#include "ManipulateData.h"
#include "Contact.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CManipulateDataDlg, CDialog)

CManipulateDataDlg::CManipulateDataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManipulateDataDlg::IDD, pParent)
	, m_nContactVersion(0)
		, m_strFirstName("")
		, m_strLastName("")
		, m_strAddress("")
		, m_strPhone("")
		, m_strMobilePhone("")
		, m_strEmail("")
		, m_strFilePath("")
		, m_iLastSelected(0)
{
}

CManipulateDataDlg::~CManipulateDataDlg()
{
}

void CManipulateDataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_FIRSTNAME, m_strFirstName);
	DDX_Text(pDX, IDC_EDIT_LASTNAME, m_strLastName);
	DDX_Text(pDX, IDC_EDIT_ADDRESS, m_strAddress);
	DDX_Text(pDX, IDC_EDIT_PHONE, m_strPhone);
	DDX_Text(pDX, IDC_EDIT_MOBILE_PHONE, m_strMobilePhone);
	DDX_Text(pDX, IDC_EDIT_EMAIL, m_strEmail);
	DDX_Control(pDX, IDC_LIST_ADRESS_BOOK, m_cList);
}

BEGIN_MESSAGE_MAP(CManipulateDataDlg, CDialog)
	ON_BN_CLICKED(IDC_RADIO_VERSION_1, &CManipulateDataDlg::OnBnClickedRadioVersion1)
	ON_BN_CLICKED(IDC_RADIO_VERSION_2, &CManipulateDataDlg::OnBnClickedRadioVersion2)
	ON_BN_CLICKED(IDC_BTN_ADD_DATA_TO_GRID, &CManipulateDataDlg::OnBnClickedBtnAddDataToGrid)
	ON_BN_CLICKED(IDC_BTN_REMOVE_DATA_FROM_GRID, &CManipulateDataDlg::OnBnClickedBtnRemoveDataFromGrid)
	ON_BN_CLICKED(IDC_BTN_CLEAN_THE_LIST, &CManipulateDataDlg::OnBnClickedBtnCleanTheList)
	ON_BN_CLICKED(IDC_BTN_UPDATE_DATA_FROM_GRID, &CManipulateDataDlg::OnBnClickedBtnUpdateDataFromGrid)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_ADRESS_BOOK, &CManipulateDataDlg::OnNMDblclkListAdressBook)
END_MESSAGE_MAP()


// CManipulateDataDlg message handlers

BOOL CManipulateDataDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_cList.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

	switch (m_pAddressDoc->GetFileVersion())
	{
	case 1:
		((CButton*)GetDlgItem(IDC_RADIO_VERSION_1))->SetCheck(BST_CHECKED);
		((CButton*)GetDlgItem(IDC_RADIO_VERSION_2))->SetCheck(BST_UNCHECKED);
		OnBnClickedRadioVersion1();
		break;
	case 2:
		((CButton*)GetDlgItem(IDC_RADIO_VERSION_1))->SetCheck(BST_UNCHECKED);
		((CButton*)GetDlgItem(IDC_RADIO_VERSION_2))->SetCheck(BST_CHECKED);
		OnBnClickedRadioVersion2();
		break;
	default:
		break;
	}

	PopulateList();

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}



void CManipulateDataDlg::OnBnClickedRadioVersion1()
{
	GetDlgItem(IDC_EDIT_FIRSTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_LASTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ADDRESS)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_MOBILE_PHONE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EMAIL)->EnableWindow(FALSE);
	m_nContactVersion = 1;	
	m_pAddressDoc->SetFileVersion(m_nContactVersion);

	ResetAllColumns();
	m_cList.InsertColumn(0, _T("First Name"), LVCFMT_LEFT,80);
	m_cList.InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
	m_cList.InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
	m_cList.InsertColumn(3, _T("Phone"), LVCFMT_LEFT,70);

	PopulateList();
}

void CManipulateDataDlg::OnBnClickedRadioVersion2()
{
	GetDlgItem(IDC_EDIT_FIRSTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_LASTNAME)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_ADDRESS)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_MOBILE_PHONE)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EMAIL)->EnableWindow(TRUE);
	m_nContactVersion = 2;
	m_pAddressDoc->SetFileVersion(m_nContactVersion);

	ResetAllColumns();
	m_cList.InsertColumn(0, _T("First Name"), LVCFMT_LEFT,80);
	m_cList.InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
	m_cList.InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
	m_cList.InsertColumn(3, _T("Phone"), LVCFMT_LEFT,70);
	m_cList.InsertColumn(4, _T("Mobile.Phone"), LVCFMT_LEFT,70);
	m_cList.InsertColumn(5, _T("E-mail"), LVCFMT_LEFT,100);

	PopulateList();
}

void CManipulateDataDlg::ResetMembers()
{
	m_strFirstName		= _T("");
	m_strLastName		= _T("");
	m_strAddress		= _T("");
	m_strPhone			= _T("");
	m_strMobilePhone	= _T("");
	m_strEmail			= _T("");
	UpdateData(FALSE);
}

void CManipulateDataDlg::OnBnClickedBtnAddDataToGrid()
{
	UpdateData(TRUE);
	int nCurrentItem = m_cList.GetItemCount() + 1;
	
	if (m_strFirstName == _T("") || (m_strLastName == _T("")))
	{
		AfxMessageBox(_T("Some of FirstName and LastName fields are empty! You cannot add to list this record."), MB_OK);
		return;
	}

	nCurrentItem = m_cList.InsertItem(nCurrentItem, m_strFirstName);
	m_cList.SetItemText(nCurrentItem, 1, m_strLastName);
	m_cList.SetItemText(nCurrentItem, 2, m_strAddress);
	m_cList.SetItemText(nCurrentItem, 3, m_strPhone);

	if (m_nContactVersion == 1)
	{
		// add a new contact to the book
		Contact newContact(m_strFirstName, m_strLastName, m_strAddress, m_strPhone);
		m_pAddressDoc->AddContact(newContact);
	}
	else if (m_nContactVersion == 2)
	{
		// set two more fields
		m_cList.SetItemText(nCurrentItem, 4, m_strMobilePhone);
		m_cList.SetItemText(nCurrentItem, 5, m_strEmail);

		// add a new contact to the book
		Contact newContact(m_strFirstName, m_strLastName, m_strAddress, m_strPhone, m_strMobilePhone, m_strEmail);
		m_pAddressDoc->AddContact(newContact);
	}
	
	ResetMembers();
}

void CManipulateDataDlg::OnBnClickedBtnRemoveDataFromGrid()
{
	POSITION pos;

	pos = m_cList.GetFirstSelectedItemPosition();
	
	if (pos != NULL)
	{
		long nCurrentPos = (long)pos - 1;
		m_cList.DeleteItem(nCurrentPos);
	}
}

void CManipulateDataDlg::PopulateList()
{
	// delete all current members
	m_cList.DeleteAllItems();

	// get a reference to the contacts list
	const ContactList& contacts = m_pAddressDoc->GetContacts();

	// iterate over all contacts add add them to the list
	int nCurrentItem = 0;
	POSITION pos = contacts.GetHeadPosition();
	while(pos != NULL)
	{
		const Contact contact = contacts.GetNext(pos);

		nCurrentItem = m_cList.InsertItem(nCurrentItem, contact.GetFirstName());
		m_cList.SetItemText(nCurrentItem, 1, contact.GetLastName());
		m_cList.SetItemText(nCurrentItem, 2, contact.GetAddress());
		m_cList.SetItemText(nCurrentItem, 3, contact.GetPhoneNumber());

		
		switch(m_pAddressDoc->GetFileVersion())
		{
		case 1:
			break;
		case 2:
			m_cList.SetItemText(nCurrentItem, 4, contact.GetMobileNumber());
			m_cList.SetItemText(nCurrentItem, 5, contact.GetEmail());
			break;
		}
	}
}

void CManipulateDataDlg::OnBnClickedBtnCleanTheList()
{
	if (m_cList.GetItemCount() > 0)
	{
		m_cList.DeleteAllItems();
	}

	m_pAddressDoc->m_cContactsList.RemoveAll();
	PopulateList();
}

void CManipulateDataDlg::ResetAllColumns(void)
{
	int nColumnCount = m_cList.GetHeaderCtrl()->GetItemCount();
	for (int i=0; i < nColumnCount; i++)
		m_cList.DeleteColumn(0); 
}

void CManipulateDataDlg::OnNMDblclkListAdressBook(NMHDR *pNMHDR, LRESULT *pResult)
{
	POSITION pos;

	pos = m_cList.GetFirstSelectedItemPosition();

	if(NULL != pos)
	{
		m_iLastSelected = (int)pos - 1;
		m_strFirstName	= m_cList.GetItemText(m_iLastSelected,0);
		m_strLastName	= m_cList.GetItemText(m_iLastSelected,1);
		m_strAddress	= m_cList.GetItemText(m_iLastSelected,2);
		m_strPhone		= m_cList.GetItemText(m_iLastSelected,3);

		if (2 == m_pAddressDoc->GetFileVersion())
		{
			m_strMobilePhone	= m_cList.GetItemText(m_iLastSelected,4);
			m_strEmail			= m_cList.GetItemText(m_iLastSelected,5);
		}
	}

	UpdateData(FALSE);

	*pResult = 0;
}

void CManipulateDataDlg::OnBnClickedBtnUpdateDataFromGrid()
{
	UpdateData(TRUE);

	Contact contact;
	contact.SetFirstName(m_strFirstName);
	contact.SetLastName(m_strLastName);
	contact.SetAddress(m_strAddress);
	contact.SetPhoneNumber(m_strPhone);	

	if (2 == m_pAddressDoc->GetFileVersion())
	{
		contact.SetMobileNumber(m_strMobilePhone);
		contact.SetEmail(m_strEmail);
	}

	m_pAddressDoc->UpdateContact(m_strFirstName, contact);

	ResetMembers();
	PopulateList();
}
