// MultiDocManager.cpp : implementation file
//

#include "stdafx.h"
#include "SerAddressBookMDI.h"
#include "MultiDocManager.h"


// CMultiDocManager

CMultiDocManager::CMultiDocManager()
{
}

CMultiDocManager::~CMultiDocManager()
{
}

//this is a copy and paste from MFC's DOCMGR.cpp (bad programming style)

AFX_STATIC void AFXAPI _AfxAppendFilterSuffix(CString& filter, OPENFILENAME& ofn, CDocTemplate* pTemplate, CString* pstrDefaultExt)
{
	ASSERT_VALID(pTemplate);
	ASSERT_KINDOF(CDocTemplate, pTemplate);

	CString strFilterExt, strFilterName;
	if (pTemplate->GetDocString(strFilterExt, CDocTemplate::filterExt) &&
		!strFilterExt.IsEmpty() &&
		pTemplate->GetDocString(strFilterName, CDocTemplate::filterName) &&
		!strFilterName.IsEmpty())
	{
		// a file based document template - add to filter list
		ASSERT(strFilterExt[0] == '.');
		if (pstrDefaultExt != NULL)
		{
			// set the default extension
			*pstrDefaultExt = ((LPCTSTR)strFilterExt) + 1;  // skip the '.'
			ofn.lpstrDefExt = (LPTSTR)(LPCTSTR)(*pstrDefaultExt);
			ofn.nFilterIndex = ofn.nMaxCustFilter + 1;  // 1 based number
		}

		// add to filter
		filter += strFilterName;
		ASSERT(!filter.IsEmpty());  // must have a file type name
		filter += (TCHAR)'\0';  // next string please
		filter += (TCHAR)'*';

		//if there is a semicolon, instert a * for the second extension (e.g. change .ex1;.ex2 to .ex1;*.ex2
		strFilterExt.Replace(_T(";."), _T(";*."));


		filter += strFilterExt;
		filter += (TCHAR)'\0';  // next string please
		ofn.nMaxCustFilter++;
	}
}


// overriding DoPromptFileName so it shows all the file types (except the first one)
//		the first one (only for opening files)		*.ex1;*.ex2
//		the second one								*.ex1
//		the third one								*.ex2
//		the default one (added to everything)		*.*

BOOL CMultiDocManager::DoPromptFileName(CString& fileName, UINT nIDSTitle, DWORD lFlags, BOOL bOpenFileDialog, CDocTemplate* pTemplate)
{
	CFileDialog dlgFile(bOpenFileDialog);

	CString title;
	VERIFY(title.LoadString(nIDSTitle));

	dlgFile.m_ofn.Flags |= lFlags;

	CString strFilter;
	CString strDefault;
	if (pTemplate != NULL)
	{
		ASSERT_VALID(pTemplate);
		_AfxAppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate, &strDefault);
	}
	else
	{
		// do for all doc template
		POSITION pos = m_templateList.GetHeadPosition();

		if(!bOpenFileDialog)	
			m_templateList.GetNext(pos); 

		BOOL bFirst = TRUE;
		while (pos != NULL)
		{
			CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
			_AfxAppendFilterSuffix(strFilter, dlgFile.m_ofn, pTemplate,
				bFirst ? &strDefault : NULL);
			bFirst = FALSE;
		}
	}


	// append the "*.*" all files filter
	CString allFilter;
	VERIFY(allFilter.LoadString(AFX_IDS_ALLFILTER));
	strFilter += allFilter;
	strFilter += (TCHAR)'\0';   // next string please
	strFilter += _T("*.*");
	strFilter += (TCHAR)'\0';   // last string
	dlgFile.m_ofn.nMaxCustFilter++;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	INT_PTR nResult = dlgFile.DoModal();
	fileName.ReleaseBuffer();
	return nResult == IDOK;
}



void CMultiDocManager::OnFileNew()
{
	if (m_templateList.IsEmpty())
	{
		TRACE0("Error: no document templates registered with CWinApp.\n");
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		return;
	}

	CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetHead();

	ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);

	pTemplate->OpenDocumentFile(NULL);
	// if returns NULL, the user has already been alerted
}


// "New" documents of other types 
CDocument* CMultiDocManager::CreateNewDocument(int doc_index, CString filename)
{
	// Find the correct document template and create a document from it
	CDocument    *pDoc = NULL;
	if (m_templateList.GetCount() >= doc_index)
	{
		POSITION    pos = m_templateList.GetHeadPosition();
		CDocTemplate *pTemplate = NULL;
		// iterate through the list looking for the required document type
		if (doc_index == 0)
		{
			pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
		}
		while (pos != NULL && doc_index > 0)
		{
			pTemplate = (CDocTemplate*)m_templateList.GetNext(pos);
			ASSERT_KINDOF(CDocTemplate, pTemplate);
		}
		if (pTemplate != NULL)
		{
			// create the document
			if (filename == "")
			{
				pDoc = pTemplate->OpenDocumentFile(NULL);
			}
			else
			{
				pDoc = pTemplate->OpenDocumentFile(filename);
			}
		}
	}
	// return the document pointer or NULL if failed
	return pDoc;
}