// SerAddressBookMDIDoc.h : interface of the CSerAddressBookMDIDoc class
//

#pragma once

#include "Contact.h"


class CSerAddressBookMDIDoc : public CDocument
{
protected: // create from serialization only
	CSerAddressBookMDIDoc();
	DECLARE_DYNCREATE(CSerAddressBookMDIDoc)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

	void SetFileVersion(UINT nFV)	{	m_nFileVersionSchema = nFV;	}
	UINT GetFileVersion() const	{	return m_nFileVersionSchema;	}

	const		ContactList& GetContacts() const {return m_cContactsList;}
	bool		AddContact(const Contact& contact);
	bool		RemoveContact(const CString& firstname, const CString& lastname);
	POSITION	FindContact(const CString& firstname) const;
	bool		FindContact(const CString& firstname, Contact& contact) const;
	bool		UpdateContact(const CString& firstname, Contact& contact);

// Implementation
public:
	virtual ~CSerAddressBookMDIDoc();
	BOOL DoSave(LPCTSTR lpszPathName, BOOL bReplace);  // need to override this
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	ContactList m_cContactsList;

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()

private:
	INT m_nFileVersionSchema;
};


