// SerAddressBookMDIView.cpp : implementation of the CSerAddressBookMDIView class
//

#include "stdafx.h"
#include "SerAddressBookMDI.h"

#include "SerAddressBookMDIDoc.h"
#include "SerAddressBookMDIView.h"
#include "ManipulateData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSerAddressBookMDIView

IMPLEMENT_DYNCREATE(CSerAddressBookMDIView, CListView)

BEGIN_MESSAGE_MAP(CSerAddressBookMDIView, CListView)
	ON_COMMAND(ID_MYMENU_CHANGEDATA, &CSerAddressBookMDIView::OnMymenuChangedata)
END_MESSAGE_MAP()

// CSerAddressBookMDIView construction/destruction

CSerAddressBookMDIView::CSerAddressBookMDIView() 
{
	// TODO: add construction code here
}

CSerAddressBookMDIView::~CSerAddressBookMDIView()
{
}

BOOL CSerAddressBookMDIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	return CListView::PreCreateWindow(cs);
}

void CSerAddressBookMDIView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
}


// CSerAddressBookMDIView diagnostics

#ifdef _DEBUG
void CSerAddressBookMDIView::AssertValid() const
{
	CListView::AssertValid();
}

void CSerAddressBookMDIView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CSerAddressBookMDIDoc* CSerAddressBookMDIView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSerAddressBookMDIDoc)));
	return (CSerAddressBookMDIDoc*)m_pDocument;
}
#endif //_DEBUG


// CSerAddressBookMDIView message handlers

void CSerAddressBookMDIView::CreateViews(int nFileVersion)
{
	CSerAddressBookMDIDoc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CListCtrl	*pListCtrl = &GetListCtrl();
	if (!pListCtrl)
		return;

	pListCtrl->SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	pListCtrl->DeleteAllItems();

	CHeaderCtrl *pHeader = pListCtrl->GetHeaderCtrl();
	if (NULL != pHeader)
	{
		int nColumnCount = pListCtrl->GetHeaderCtrl()->GetItemCount();
		for(int i = 0; i < nColumnCount; i++)
			pListCtrl->DeleteColumn(0);
	}

	switch (nFileVersion)
	{
		case 1:
				pListCtrl->InsertColumn(0, _T("First Name"), LVCFMT_LEFT,110);
				pListCtrl->InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
				pListCtrl->InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
				pListCtrl->InsertColumn(3, _T("Phone"), LVCFMT_LEFT,140);
			break;

		case 2:
				pListCtrl->InsertColumn(0, _T("First Name"), LVCFMT_LEFT,110);
				pListCtrl->InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
				pListCtrl->InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
				pListCtrl->InsertColumn(3, _T("Phone"), LVCFMT_LEFT,100);
				pListCtrl->InsertColumn(4, _T("Mobile Phone"), LVCFMT_LEFT,100);
				pListCtrl->InsertColumn(5, _T("E-mail"), LVCFMT_LEFT,140);
			break;

		default:	// last file version
				pListCtrl->InsertColumn(0, _T("First Name"), LVCFMT_LEFT,110);
				pListCtrl->InsertColumn(1, _T("Last name"), LVCFMT_LEFT,120);	
				pListCtrl->InsertColumn(2, _T("Address"), LVCFMT_LEFT,160);	
				pListCtrl->InsertColumn(3, _T("Phone"), LVCFMT_LEFT,100);
				pListCtrl->InsertColumn(4, _T("Mobile Phone"), LVCFMT_LEFT,100);
				pListCtrl->InsertColumn(5, _T("E-mail"), LVCFMT_LEFT,140);
			break;
	}

	DWORD dwStyle = GetWindowLong(pListCtrl->GetSafeHwnd(),GWL_STYLE);
	dwStyle |= LVS_REPORT;

	SetWindowLong(pListCtrl->GetSafeHwnd(),GWL_STYLE,dwStyle);
	SetRedraw(TRUE);
}

void CSerAddressBookMDIView::PopulateList()
{
	CSerAddressBookMDIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CreateViews(pDoc->GetFileVersion());

	CListCtrl	*pListCtrl = &GetListCtrl();
	ASSERT_VALID(pListCtrl);

	// get a reference to the contacts list
	const ContactList& contacts = pDoc->GetContacts();

	// iterate over all contacts add add them to the list
	int nCurrentItem = 0;
	POSITION pos = contacts.GetHeadPosition();
	while(pos != NULL)
	{
		const Contact contact = contacts.GetNext(pos);

		nCurrentItem = pListCtrl->InsertItem(nCurrentItem, contact.GetFirstName());
		pListCtrl->SetItemText(nCurrentItem, 1, contact.GetLastName());
		pListCtrl->SetItemText(nCurrentItem, 2, contact.GetAddress());
		pListCtrl->SetItemText(nCurrentItem, 3, contact.GetPhoneNumber());

		switch(pDoc->GetFileVersion())
		{
		case 1:
			break;
		case 2:
			pListCtrl->SetItemText(nCurrentItem, 4, contact.GetMobileNumber());
			pListCtrl->SetItemText(nCurrentItem, 5, contact.GetEmail());
			break;
		default:
			break;
		}
	}
}
void CSerAddressBookMDIView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	PopulateList();
}

void CSerAddressBookMDIView::OnMymenuChangedata()
{
	CSerAddressBookMDIDoc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CManipulateDataDlg dlg;

	dlg.SetAddressDocument(pDoc);

	if (IDOK == dlg.DoModal())
	{
		PopulateList();
	}
}